#asm
    .equ __lcd_port=0x15
#endasm
eeprom long int pass_store= 123456,master_password= 291279;
#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <lcd.h>
#include <stdio.h>
#include <delay.h>
#include <kbd.h>
#define relay PORTA.0

int i,j,k,fail=0;
long int id_value, pass_value, pass[6];
bit match=0;
void password()
{i=0;
do{
        delay_ms(50);
        while(!kbd_read()){}
        j=kbd_read();
        if(j<11)
        {if(j==10) j=0; pass[i]=j;
        lcd_gotoxy(5+i,1);
        lcd_putsf("*"); i++;}
} while(i<6);
delay_ms(100);
pass_value=pass[5]+ 10*pass[4]+ 100*pass[3]+ 1000*pass[2]+ 10000*pass[1]+ 100000*pass[0];
}
void pass_change()
{
lcd_clear(); lcd_gotoxy(0,0);
lcd_putsf("Enter New ");
lcd_gotoxy(0,1);
lcd_putsf("Password:");
delay_ms(50); k=0;
do{
delay_ms(50);
while(!kbd_read()){}
j=kbd_read();
if(j<11)
{if(j==10) j=0;
pass[k]=j;
k++;
lcd_gotoxy(9+k,1);
lcd_putsf("*");}
} while(k<6);
pass_value=pass[5]+ 10*pass[4]+ 100*pass[3]+ 1000*pass[2]+ 10000*pass[1]+ 100000*pass[0];
pass_store=pass_value;
id_value=pass_store;
delay_ms(100);
if(pass_value==id_value){lcd_clear();
lcd_putsf("Password changed");}
else {lcd_clear();
lcd_putsf("Verify failed");}
delay_ms(300);}
void unlock()
{
relay=~relay;lcd_clear();
lcd_gotoxy(1,0);
lcd_putsf("Door Unlocked");
lcd_gotoxy(2,1);
lcd_putsf("Please enter");
delay_ms(300);
for(k=0;k<20;k++)
{lcd_clear();
delay_ms(50);
lcd_gotoxy(1,0);
lcd_putsf("Door Unlocked");
lcd_gotoxy(2,1);
lcd_putsf("Please enter");
delay_ms(50);}
relay=~relay; return;
}
void main()
{
PORTA=0x00;
DDRA=0xFF;
kbd_init();
lcd_init(16);
lcd_clear();
lcd_gotoxy(4,0);
lcd_putsf("Welcome!");
delay_ms(100);
label1: lcd_clear();
lcd_gotoxy(1,0);
lcd_putsf("Enter Password:");
delay_ms(50);
password();
if(pass_value==pass_store){
match=1;
}
else if(pass_value==master_password) {
match=1;
pass_change();
match=0;
fail=0;
goto label1;
}
else {match=0;
}
if(match==1)
{
match=0;
fail=0;
delay_ms(100);
unlock();
goto label1;
}
else
{
lcd_clear();
 lcd_putsf("Invalid Password");
 match=0;
 fail=fail+1;
 delay_ms(200);
  if(fail==3)
  {
  lcd_clear();
  lcd_gotoxy(1,0);
  lcd_putsf("Contact System ");
  lcd_gotoxy(1,1);
  lcd_putsf("Administrator");
  }
   else
   {
   goto label1;
   }
   }
}
